--- net/net.gyp
+++ net/net.gyp
@@ -159,7 +159,7 @@
         '../base/base.gyp:base',
       ],
       'conditions': [
-        [ 'OS == "linux"', {
+        [ 'OS == "linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gconf',
             '../build/linux/system.gyp:gdk',
@@ -179,7 +179,7 @@
             ],
           },
         ],
-        [ 'OS == "linux"', {
+        [ 'OS == "linux" or OS == "freebsd"', {
             'sources/': [ ['exclude', '_(mac|win)\\.cc$'] ],
           },
           {  # else: OS != "linux"
@@ -496,7 +496,7 @@
             '../v8/tools/gyp/v8.gyp:v8',
           ],
         }],
-        [ 'OS == "linux"', {
+        [ 'OS == "linux" or OS == "freebsd"', {
           'dependencies': [
             '../build/linux/system.gyp:gconf',
             '../build/linux/system.gyp:gdk',
@@ -521,10 +521,10 @@
             ],
           },
         ],
-        [ 'OS == "linux"', {
+        [ 'OS == "linux" or OS == "freebsd"', {
             'sources/': [ ['exclude', '_(mac|win)\\.cc$'] ],
           },
-          {  # else: OS != "linux"
+          {  # else: OS != "linux" and OS != "freebsd"
             'sources!': [
               'ocsp/nss_ocsp.cc',
               'ocsp/nss_ocsp.h',
@@ -538,6 +538,10 @@
             ],
           },
         ],
+	[ 'OS == "freebsd"', {
+	    'sources!': [ 'proxy/proxy_config_service_linux.cc' ],
+	  },
+	],
         [ 'OS == "mac"', {
             'sources/': [ ['exclude', '_(linux|win)\\.cc$'] ],
             'link_settings': {
@@ -633,7 +637,7 @@
         'http/http_vary_data_unittest.cc',
         'proxy/init_proxy_resolver_unittest.cc',
         'proxy/mock_proxy_resolver.h',
-        'proxy/proxy_config_service_linux_unittest.cc',
+#        'proxy/proxy_config_service_linux_unittest.cc',
         'proxy/proxy_config_service_win_unittest.cc',
         'proxy/proxy_config_unittest.cc',
         'proxy/proxy_list_unittest.cc',
@@ -668,7 +672,7 @@
             ],
           },
         ],
-        [ 'OS == "linux"', {
+        [ 'OS == "linux" or OS == "freebsd"', {
             'sources/': [ ['exclude', '_(mac|win)_unittest\\.cc$'] ],
             'dependencies': [
               '../build/linux/system.gyp:gtk',
diff --git net/socket/client_socket.cc net/socket/client_socket.cc
index e01045b..6e6f11e 100644
